import matplotlib.pyplot as plt
import scipy as sp
import numpy as np
import scipy.integrate as integrate
from matplotlib.widgets import Slider

a=1
D=1e4
lamb=6.5e-3

### Nombre de source ponctuelles

Ns=500

###
I0=1

bmaxi=3*D*lamb/a


def delta(xs,x,bmax):
    return a*x/D + xs*a/D

def I1(bmax,x):
    liste_xs=np.linspace(-bmax/2,bmax/2,Ns)
    xs=liste_xs[0]
    return 2*I0*(1+np.cos(2*np.pi*delta(xs,x,bmax)/lamb))


def I2(bmax,x):
    liste_xs=np.linspace(-bmax/2,bmax/2,Ns)
    xs=liste_xs[1]
    return 2*I0*(1+np.cos(2*np.pi*delta(xs,x,bmax)/lamb))

def Ik(bmax,x,k):
    liste_xs=np.linspace(-bmax/2,bmax/2,Ns)
    xs=liste_xs[k]
    return 2*I0*(1+np.cos(2*np.pi*delta(xs,x,bmax)/lamb))


def Itot(x,bmax):
    liste_xs=np.linspace(-bmax/2,bmax/2,Ns)
    Itot=0
    for k in range(len(liste_xs)):
        xs=liste_xs[k]
        Itot+=Ik(bmax,x,k)
    return Itot

interf=lamb*D/a
liste_x=np.linspace(-2.3*interf,2.3*interf,500)


if Ns==2:
    fig = plt.figure(figsize=(10,8))
    ax = fig.add_subplot(111)
    ax_X = fig.add_axes([0.3, 0.89, 0.4, 0.05])
    ax_X.spines['top'].set_visible(True)
    ax.grid(True)

    It,=ax.plot(liste_x,Itot(liste_x,0),label='$I_{tot}$',c='red')
    I1p,=ax.plot(liste_x,I1(0,liste_x),'--',label='$I_1$',c='blue')
    I2p,=ax.plot(liste_x,I2(0,liste_x),'--',label='$I_2$',c='green')
    ax.set_xlabel('Position [10$^{-4}$m]',fontsize=20)
    ax.set_ylabel('Intensité [$I_0$]',fontsize=20)
    s_X = Slider(ax=ax_X,label=' ', valmin=0, valmax=bmaxi,valinit=0, facecolor='gray')

    def update(val):
        b= s_X.val
        It.set_data(liste_x,Itot(liste_x,b))
        I1p.set_data(liste_x,I1(b,liste_x))
        I2p.set_data(liste_x,I2(b,liste_x))
        fig.canvas.draw_idle()
    s_X.on_changed(update)
    plt.title('b $[10^{-4}m]$',fontsize=20)
    plt.grid(True)
    ax.legend(fontsize=20)
    plt.show()

else:
    fig = plt.figure(figsize=(10, 8))
    ax = fig.add_subplot(111)
    ax_X = fig.add_axes([0.3, 0.89, 0.4, 0.05])
    ax_X.spines['top'].set_visible(True)
    ax_X.spines['right'].set_visible(True)

    It,=ax.plot(liste_x,Itot(liste_x,0),label='$I_{tot}$',c='red')
    ax.grid(True)
    #I1p,=ax.plot(liste_x,I1(0,liste_x),'--',label='$I_1$',c='blue')
    #I2p,=ax.plot(liste_x,I2(0,liste_x),'--',label='$I_2$',c='green')
    ax.set_xlabel('Position [10$^{-4}$m]',fontsize=20)
    ax.set_ylabel('Intensité [$I_0$]',fontsize=20)
    s_X = Slider(ax=ax_X,label=' ', valmin=0, valmax=bmaxi,valinit=0, facecolor='gray')

    def update(val):
        b= s_X.val
        It.set_data(liste_x,Itot(liste_x,b))
        #I1p.set_data(liste_x,I1(b,liste_x))
        #I2p.set_data(liste_x,I2(b,liste_x))
        fig.canvas.draw_idle()
    s_X.on_changed(update)
    plt.title('b $[10^{-4}m]$',fontsize=20)

    ax.legend(fontsize=20)
    plt.show()
